#include "binary.h"

using namespace System;


namespace TechnoAP { namespace usbmca {

	namespace common
	{
		/// <summary>
		/// Extraction of lower 32 bits
		/// </summary>
		unsigned int binary::getLsb32bit(__int64 value)
		{
			return	(unsigned int)((value >> 0) & 0x0ffffffffll);
		}

		/// <summary>
		/// Extraction of upper 32 bits
		/// </summary>
		unsigned int binary::getMsb32bit(__int64 value)
		{
			return	(unsigned int)((value >> 32) & 0x0ffffffffll);
		}

		/// <summary>
		/// Enhancement from 48 bits to 64 bits
		/// </summary>
		__int64 binary::expand48bitTo64bit(array<Byte> ^source, int offset)
		{
			__int64		result = 0;

			array<Byte>^ abTemp = gcnew array<Byte>(8);
			Buffer::BlockCopy(source, offset, abTemp, 2, 6);

			result = BitConverter::ToInt64(abTemp, 0);
			result = Net::IPAddress::HostToNetworkOrder(result);

			return result;
		}

		/// <summary>
		/// Enhancement from 24 bits to 32 bits(host byte order)
		/// </summary>
		int binary::expand24bitTo32bit(array<Byte> ^source, int offset)
		{
			int		result = 0;

			array<Byte> ^abTemp = gcnew array<Byte>(4);
			Array::Clear(abTemp, 0, abTemp->Length);

			result = BitConverter::ToInt32(abTemp, 0);
			result = Net::IPAddress::HostToNetworkOrder(result);

			return result;
		}

		/// <summary>
		/// Conversion from 4 byte array to 32 bit variable(host byte order)
		/// </summary>
		int binary::arrayToUnit32bit(array<Byte> ^source, int offset)
		{
			int result;

			array<Byte> ^abTemp = gcnew array<Byte>(4);
			Array::Clear(abTemp, 0, abTemp->Length);
			Buffer::BlockCopy(source, offset, abTemp, 0, 4);

			result = BitConverter::ToInt32(abTemp, 0);
			result = System::Net::IPAddress::HostToNetworkOrder(result);

			return result;
		}

		/// <summary>
		/// Reduce from 48 bits to 32 bits (as an array)
		/// </summary>
		array<Byte>^ binary::contract64bitTo48bit(__int64 value)
		{
			array<Byte> ^abResult = gcnew array<Byte>(6);

			__int64 wvalue = System::Net::IPAddress::NetworkToHostOrder(value);
			array<Byte> ^abWork = BitConverter::GetBytes(wvalue);
			Buffer::BlockCopy(abWork, 2, abResult, 0, abResult->Length);

			return abResult;
		}
	}
} }


