#include "command.h"
#include "constant\constant.h"

using namespace System;


namespace TechnoAP { namespace usbmca {

	namespace common
	{
		using namespace TechnoAP::usbmca;

		/// <summary>
		/// Generation of command telegram
		/// </summary>
		array<Byte>^ command::createTelegram(String ^command, int channel, unsigned int value)
		{
			array<Byte> ^result = gcnew array<Byte>(8);

			String ^wcommand = createCommand(command, channel);

			if (String::IsNullOrEmpty(wcommand) == false) {
				array<Byte> ^abCommand = System::Text::Encoding::ASCII->GetBytes(wcommand);

				int nWork = System::Net::IPAddress::NetworkToHostOrder((int)(value));
				array<Byte> ^abValue = BitConverter::GetBytes(nWork);

				Buffer::BlockCopy(abCommand, 0, result, 0, 4);
				Buffer::BlockCopy(abValue, 0, result, 4, 4);
			}
			else {
				result = nullptr;
			}

			return result;
		}

		/// <summary>
		/// Extraction from command telegram
		/// </summary>
		/// <param name="abAnswer">command telegram</param>
		/// <param name="value">parameter value</param>
		/// <returns>command text</returns>
		String^ command::restoreCommand(array<Byte> ^abAnswer, unsigned int% value)
		{
			String ^result = String::Empty;

			array<Byte> ^abWork = gcnew array<Byte>(5);
			Array::Clear(abWork, 0, abWork->Length);
			Array::Copy(abAnswer, abWork, 4);

			result = System::Text::Encoding::ASCII->GetString(abWork);

			int wvalue = BitConverter::ToInt32(abAnswer, 4);
			value = (unsigned int)Net::IPAddress::NetworkToHostOrder(wvalue);

			return result;
		}

		/// <summary>
		/// Generate command string
		/// </summary>
		String^ command::createCommand(String^ command, int channel)
		{
			String ^result = String::Empty;

			String ^strIFG = const_cast<String^>(constant::Command::IFG);
			String ^strIOF = const_cast<String^>(constant::Command::IOF);

			switch ((constant::CH_TYPE)(channel)) {
			case constant::CH_TYPE::Common:		// Common commands
				result = command;
				break;
			case constant::CH_TYPE::CH1:		// CH1
				result = command + "W";

				if ((constant::Command::isChCommand(command, strIFG) == true) ||
					(constant::Command::isChCommand(command, strIOF) == true)) {
					result = command + "0";
				}

				break;
			case constant::CH_TYPE::CH2:	// CH2
			case constant::CH_TYPE::CH3:	// CH3
			case constant::CH_TYPE::CH4:	// CH4
				result = String::Format("{0}{1}", command, (channel - 1));
				break;
			default:
				break;
			}

			return result;

		}

	}
} }


