#include "config.h"
#include "common\binary.h"
#include "common\command.h"
#include "common\convert.h"
#include "constant\constant.h"

using namespace System;
using namespace System::IO;
using namespace System::Text;
using namespace System::Collections::Generic;


namespace TechnoAP { namespace usbmca {
	
	using namespace FTD2XX_NET;
	using namespace TechnoAP::usbmca;

	namespace device
	{
		/// <summary>
		/// constractor
		/// </summary>
		config::config(device ^clsDevice)
		{
			mDevice = clsDevice;
		}

		/// <summary>
		/// Copying parameters (array)
		/// </summary>
		void config::CopyConfigData(array<unsigned int> ^source, array<unsigned int> ^destination)
		{
			Array::Copy(source, destination, destination->Length);
		}

		/// <summary>
		/// Copying parameters
		/// </summary>
		void config::CopyConfigData(array<unsigned int> ^destination, UInt32 uCh1, UInt32 uCh2, UInt32 uCh3, UInt32 uCh4)
		{
			array<unsigned int> ^anConfig = gcnew array<unsigned int>(constant::Max::CH);

			anConfig[0] = uCh1;
			anConfig[1] = uCh2;
			anConfig[2] = uCh3;
			anConfig[3] = uCh4;
			CopyConfigData(anConfig, destination);
		}

		/// <summary>
		/// Writing measurement parameters
		/// </summary>
		bool config::Write(void)
		{
			array<bool> ^astResult = gcnew array<bool>(32);
			
			bool result = true;

			for (int i = 0; i < astResult->Length; i++) {
				astResult[i] = true;
			}

			for (int i = 0; i < constant::Max::CH; i++) {
				int index = 0;
				unsigned int uOutput = 0;

				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::ADG), (i + 1), manADG[i], uOutput);
				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::THR), (i + 1), manTHR[i], uOutput);
				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::LLD), (i + 1), manLLD[i], uOutput);
				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::ULD), (i + 1), manULD[i], uOutput);
				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::OFS), (i + 1), manOFS[i], uOutput);
				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::PDSW), 0, (UInt32)muPDS, uOutput);
#if false
				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::IOF), (i + 1), manIOF[i], uOutput);
				astResult[index++] = mDevice->OrderCommand(const_cast<String^>(constant::Command::IFG), (i + 1), manIFG[i], uOutput);
#endif
				for (int j = 0; j < index; j++) {
					if (astResult[j] == false) {
						// There is an error
						result = false;
						break;
					}
				}
			}

			return result;
		}

	}
} }


