#include "status.h"
#include "common\binary.h"
#include "common\command.h"
#include "common\convert.h"
#include "constant\constant.h"

using namespace System;
using namespace System::IO;
using namespace System::Text;
using namespace System::Collections::Generic;


namespace TechnoAP { namespace usbmca {
	
	using namespace FTD2XX_NET;
	using namespace TechnoAP::usbmca;

	namespace device
	{
		/// <summary>
		/// constractor
		/// </summary>
		status::status()
		{
			for (int i = 0; i < maChannel->Length; i++) {
				maChannel[i] = gcnew status_ch();
			}
		}

		/// <summary>
		/// Organization of measurement status
		/// </summary>
		status^ status::analyzeData(array<Byte> ^abStatus)
		{
			mRealTime = common::binary::expand48bitTo64bit(abStatus, 0);

			for(int i = 0; i < maChannel->Length; i++) {
				int index = 6 + (22 * i);
				maChannel[i]->mLiveTime = common::binary::expand48bitTo64bit(abStatus, (index + 0));
				maChannel[i]->mDeadTime = common::binary::expand48bitTo64bit(abStatus, (index + 6));
				maChannel[i]->mThroughputRate = (UInt32)common::binary::expand24bitTo32bit(abStatus, (index + 12));
				maChannel[i]->mThroughputCount = (UInt32)common::binary::arrayToUnit32bit(abStatus, (index + 15));
				maChannel[i]->mInputRate = (UInt32)common::binary::expand24bitTo32bit(abStatus, (index + 19));
			}

			return	this;
		}

		/// <summary>
		/// get elapsed time in milliseconds
		/// </summary>
		__int64 status::getElapsedTimeMillisoconds(void)
		{
			return common::convert::CountToMilliseconds(mRealTime);
		}

		/// <summary>
		/// get elapsed time in nanoseconds
		/// </summary>
		__int64 status::getElapsedTimeNanoseconds(void)
		{
			return common::convert::CountToNanoseconds(mRealTime);
		}


	}
} }


